-- name: [CS] \\#E77100\\AiAi (Super Monkey Ball)
-- description: Alright! You've downloaded the AiAi! Filled with happiness, eek-eek-kee! Can't stop laughing, ha-ha-hoo! Magical spell is Ei-Ei-POO! You are Super Mario 64's best friend!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

local TEXT_MOD_NAME = "AiAi"
local TEXT_MOD_VERSION = "1.0"

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_AIAI = smlua_model_util_get_id("aiai_geo")

local TEX_AIAI_LIFE_ICON = get_texture_info("aiai-icon")

local VOICETABLE_CHAR = {
	[CHAR_SOUND_UH] = 'Uhn.ogg',
	[CHAR_SOUND_HRMM] = 'Hrumph.ogg',
	[CHAR_SOUND_EEUH] = 'Ledge-Climb.ogg',
	[CHAR_SOUND_UH2] = 'Uhn-02.ogg',
	[CHAR_SOUND_UH2_2] = 'Uhn-02.ogg',
	[CHAR_SOUND_PANTING_COLD] = 'ooh.ogg',
	[CHAR_SOUND_PANTING] = {'ooh.ogg', 'woah.ogg', 'Lose-Health.ogg', 'Hrumph.ogg'},
	[CHAR_SOUND_COUGHING1] = 'cough.ogg',
	[CHAR_SOUND_COUGHING2] = 'cough.ogg',
	[CHAR_SOUND_COUGHING3] = 'cough.ogg',
	[CHAR_SOUND_LETS_A_GO] = 'Lets-a-go.ogg',
	[CHAR_SOUND_ATTACKED] = 'Lose-Health.ogg',
    [CHAR_SOUND_DOH] = 'Doh.ogg',
    [CHAR_SOUND_DROWNING] = 'drowning.ogg',
    [CHAR_SOUND_DYING] = 'Uhh-Ooph.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Wah-02.ogg',
    [CHAR_SOUND_HAHA] = 'Haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Here-we-go.ogg',
    [CHAR_SOUND_HOOHOO] = 'hoohoo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'mamma-mia.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'okey-dokey.ogg',
    [CHAR_SOUND_ON_FIRE] = 'hot-hot-hot.ogg',
    [CHAR_SOUND_OOOF] = 'ooph.ogg',
    [CHAR_SOUND_OOOF2] = 'oh.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'Hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'wah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Yah.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'So-Long-Bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'boing.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Wahhh.ogg',
    [CHAR_SOUND_WAH2] = 'Wah-02.ogg',
    [CHAR_SOUND_WHOA] = 'Hrumph.ogg',
    [CHAR_SOUND_YAHOO] = 'Yah2.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'Yippie.ogg', 'Wahah.ogg', 'Yahoo.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'Yah.ogg', 'Yahoo.ogg', 'yawn.ogg'},
    [CHAR_SOUND_YAWNING] = 'yawn.ogg',
}

local PALETTE_CHAR = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "E77100",
    [GLOVES] = "ffffff",
    [SHOES]  = "ffffff",
    [HAIR]   = "5A2D00",
    [SKIN]   = "D49670",
    [CAP]    = "ffffff",
	[EMBLEM] = "ffffff",
}

-- Mod By Mr. Sneaky!

local CSloaded = false
local function on_character_select_load()
    CT_CHAR = _G.charSelect.character_add("AiAi", {"I really love bananas!", "Introducing AiAi from Super Monkey Ball!"}, "Mr. Sneaky, Sega, Nintendo", {r = 231, g = 113, b = 0}, E_MODEL_AIAI, CT_MARIO, TEX_AIAI_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MODEL_AIAI, CAPTABLE_CHAR)
    _G.charSelect.character_add_voice(E_MODEL_AIAI, VOICETABLE_CHAR)
    _G.charSelect.character_add_celebration_star(E_MODEL_AIAI, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_AIAI, PALETTE_CHAR)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)